# Class Module

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.Module

All Implemented Interfaces:
  `Cloneable, Node`

public final class Module extends Attribute
This class is derived from Attribute and represents the list of modules required, exported, opened or provided by a module. There may be at most one Module attribute in a ClassFile structure.

Since:
  6.4.0
See Also:
  - `Attribute`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `EXTENSION`
  The module file name extension.

  ### Fields inherited from class Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  Creates a deep copy of this attribute.
  `void`
  `dump(DataOutputStream file)`
  Dumps Module attribute to file stream in binary format.
  `ModuleExports[]`
  `getExportsTable()`
  `int`
  `getModuleFlags()`
  Gets flags for this module.
  `String`
  `getModuleName(ConstantPool cp)`
  Gets module name.
  `ModuleOpens[]`
  `getOpensTable()`
  `ModuleProvides[]`
  `getProvidesTable()`
  `ModuleRequires[]`
  `getRequiresTable()`
  `String[]`
  `getUsedClassNames(ConstantPool constantPool, boolean compactClassName)`
  Gets the array of class names for this module's uses.
  `String`
  `getVersion(ConstantPool cp)`
  Gets version for this module.
  `String`
  `toString()`

  ### Methods inherited from class Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### EXTENSION

    public static final String EXTENSION
    The module file name extension.
    Since:
      6.7.0
    See Also:
      - Constant Field Values

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object.

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Description copied from class: `Attribute`
    Creates a deep copy of this attribute.
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute.

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dumps Module attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `file` - Output file stream.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getExportsTable

    public ModuleExports[] getExportsTable()
    Returns:
      table of exported interfaces.
    See Also:
      - `ModuleExports`

  - ### getModuleFlags

    public int getModuleFlags()
    Gets flags for this module.
    Returns:
      module flags.
    Since:
      6.10.0

  - ### getModuleName

    public String getModuleName(ConstantPool cp)
    Gets module name.
    Parameters:
      `cp` - Array of constants.
    Returns:
      module name.
    Since:
      6.10.0

  - ### getOpensTable

    public ModuleOpens[] getOpensTable()
    Returns:
      table of provided interfaces.
    See Also:
      - `ModuleOpens`

  - ### getProvidesTable

    public ModuleProvides[] getProvidesTable()
    Returns:
      table of provided interfaces.
    See Also:
      - `ModuleProvides`

  - ### getRequiresTable

    public ModuleRequires[] getRequiresTable()
    Returns:
      table of required modules.
    See Also:
      - `ModuleRequires`

  - ### getUsedClassNames

    public String[] getUsedClassNames(ConstantPool constantPool, boolean compactClassName)
    Gets the array of class names for this module's uses.
    Parameters:
      `constantPool` - Array of constants usually obtained from the ClassFile object.
      `compactClassName` - false for original constant pool value, true to replace '/' with '.'.
    Returns:
      array of used class names.
    Since:
      6.10.0

  - ### getVersion

    public String getVersion(ConstantPool cp)
    Gets version for this module.
    Parameters:
      `cp` - Array of constants.
    Returns:
      version from constant pool, "0" if version index is 0.
    Since:
      6.10.0

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation, that is, a list of packages.